/**************************************************************************
 * Devil Plugin Copyright (C) 2007-2008 Mikhail Polenin                   *
 * HeXHub is Copyright(C) Albu Cristian Laurentiu                         *
 * This plugin is licensed under the Open Software License 3.0            *
 * Please read the license before making a modification to this plugin.   *
 * Failure to follow the terms of the license will have severe            *
 * consequences                                                           *
 **************************************************************************/

#include "devillist.h"

devillist::devillist()
{
	this->first = 0;
	this->last = 0;
	InitializeCriticalSection(&cs);
}

devillist::~devillist()
{
	listitem *pos;
	listitem *forward;
	EnterCriticalSection(&cs);
	while(pos != 0)
	{
		forward = pos->next;
		delete pos;
		pos = forward;
	}
	LeaveCriticalSection(&cs);
	DeleteCriticalSection(&cs);
}

BOOL devillist::AddItem(char *nick)
{
	listitem *it = new listitem;
	memcpywithnull(it->nick, nick, 40);
	EnterCriticalSection(&cs);
	if(this->first == 0){
		this->first = it;
		this->last = it;
	} else {
		this->last->next = it;
		this->last = it;
	}
	LeaveCriticalSection(&cs);
	return true;
}

BOOL devillist::Find(char *nick)
{
	listitem *it = this->first;
	listitem *forward;
	EnterCriticalSection(&cs);
	while(it != 0)
	{
		forward = it->next;
		if(strcmp(nick, it->nick) == 0)
		{
			LeaveCriticalSection(&cs);
			return true;
		}
		it = forward;
	}
	LeaveCriticalSection(&cs);
	return false;
}

listitem *devillist::Previous(listitem *idx)
{
	listitem *bla = this->first;
	if(idx = this->first)
		return this->first;
	while(bla->next != idx) bla = bla->next;
	return bla;
}

BOOL devillist::RemoveItem(char *nick)
{
	listitem *temp;
	listitem *it = this->first;
	listitem *forward;
	EnterCriticalSection(&cs);
	while(it != 0)
	{
		forward = it->next;
		if(strcmp(nick, it->nick) == 0)
		{
			if(it == this->first) { 
				temp = this->first; 
				this->first = this->first->next; 
				delete[] temp; 
			}
			else if(it == this->last) { 
				temp = this->last; 
				this->last = Previous(this->last); 
				this->last->next = NULL; 
				delete[] temp; 
			}
			else { 
				temp = Previous(it); 
				temp->next = it->next; 
				delete[] it; 
			}
			LeaveCriticalSection(&cs);
			return true;
		}
		it = forward;
	}
	LeaveCriticalSection(&cs);
	return false;
}