/**************************************************************************
 * Devil Plugin Copyright (C) 2007-2008 Mikhail Polenin                   *
 * HeXHub is Copyright(C) Albu Cristian Laurentiu                         *
 * This plugin is licensed under the Open Software License 3.0            *
 * Please read the license before making a modification to this plugin.   *
 * Failure to follow the terms of the license will have severe            *
 * consequences                                                           *
 **************************************************************************/

#include "HeXHubSDK.h"
#include "devillist.h"
#include <string>
#include <sstream>

long cmdId, seccmdId;
long hlpId, sechlpId;
devillist *dl = new devillist;

void HEXHUBAPI onDvlCommand(SDWORD dwCommandId, SDWORD userId, LPVOID rights, const char *commandParameters, BOOL isPM);
void HEXHUBAPI onUnDvlCommand(SDWORD dwCommandId, SDWORD userId, LPVOID rights, const char *commandParameters, BOOL isPM);

const char * HEXHUBAPI InitPlugin(lpfnGetFunction HexGetFunction) {
	HexHub Hex;
	if(Hex.Initialize(HexGetFunction) == false) return 0;

	if ((cmdId = HexHub::Core::RegisterCommand("devilize", onDvlCommand)) == -1) return 0;
	if ((seccmdId = HexHub::Core::RegisterCommand("undevilize", onUnDvlCommand)) == -1) return 0;

	if ((hlpId = HexHub::Core::RegisterHelpString("EN", "!devilize <nick>\t\t\t-\tMake a user speak like TheDeBiL", 1)) == -1) return 0;
	if ((sechlpId = HexHub::Core::RegisterHelpString("EN", "!undevilize <nick>\t\t\t-\tReverse effects of !devilize", 1)) == -1) return 0;

	return "Devil Plugin version 0.1 by The Architect";
}


void HEXHUBAPI onDvlCommand(SDWORD dwCommandId, SDWORD userId, LPVOID rights, const char *commandParameters, BOOL isPM)
{
	char nick[40];
	char sender[40];

	memset(nick, 0, 40);
	memset(sender, 0, 40);

	int i = 0;

	for (i=0; (i < 40) && (commandParameters[i] != '|') && (commandParameters[i] != 0); i++) nick[i] = commandParameters[i];
	for (i=0; nick[i] != 0; i++) {
		if (nick[i] == ' ') {
			nick[i] = 0;
			break;
		}
	}
	
	SDWORD dwVictimId = 0;

	std::stringstream snd;

	if(!dl->Find(nick))
	{
		if((dwVictimId = HexHub::Users::IdFromNick(nick)) > -1)
		{
			if(HexHub::Users::Registration::GetAccessLevel(userId) >= HexHub::Users::Registration::GetAccessLevel(dwVictimId))
			{
				dl->AddItem(nick);
				snd << "*** You have DeBiLiZeD " << nick << "|";
				HexHub::Data::SendTo(userId, snd.str().c_str(), snd.str().length());
			}
			else
			{
				snd << "*** Insufficient Access Level.|";
				HexHub::Data::SendTo(userId, snd.str().c_str(), snd.str().length());
			}
		}
		else
		{
			snd << "** User " << nick << " is not connected to this hub!|";
			HexHub::Data::SendTo(userId, snd.str().c_str(), snd.str().length());
		}
	}
	else
	{
		snd << "*** User " << nick << " is already debilized!|";
		HexHub::Data::SendTo(userId, snd.str().c_str(), snd.str().length());
	}
}

void HEXHUBAPI onUnDvlCommand(SDWORD dwCommandId, SDWORD userId, LPVOID rights, const char *commandParameters, BOOL isPM)
{
	char nick[40];
	char sender[40];

	memset(nick, 0, 40);
	memset(sender, 0, 40);

	int i = 0;

	for (i=0; (i < 40) && (commandParameters[i] != '|') && (commandParameters[i] != 0); i++) nick[i] = commandParameters[i];
	for (i=0; nick[i] != 0; i++) {
		if (nick[i] == ' ') {
			nick[i] = 0;
			break;
		}
	}
	
	SDWORD dwVictimId = 0;

	std::stringstream snd;

	if(dl->Find(nick))
	{
		if((dwVictimId = HexHub::Users::IdFromNick(nick)) > -1)
		{
			if(HexHub::Users::Registration::GetAccessLevel(userId) >= HexHub::Users::Registration::GetAccessLevel(dwVictimId))
			{
				dl->RemoveItem(nick);
				snd << "*** You have Un-DeBiLiZeD " << nick << "|";
				HexHub::Data::SendTo(userId, snd.str().c_str(), snd.str().length());
			}
			else
			{
				snd << "*** Insufficient Access Level.|";
				HexHub::Data::SendTo(userId, snd.str().c_str(), snd.str().length());
			}
		}
		else
		{
			snd << "*** User " << nick << " is not connected to this hub!|";
			HexHub::Data::SendTo(userId, snd.str().c_str(), snd.str().length());
		}
	}
	else
	{
		snd << "*** User " << nick << " is not debilized!|";
		HexHub::Data::SendTo(userId, snd.str().c_str(), snd.str().length());
	}
}

const char * HEXHUBAPI GetAboutText(void) {
	return "Mikhail Polenin, 2007 - 2008, Release date: " __DATE__ " " __TIME__ "";
}

BOOL HEXHUBAPI onChatMessage(SDWORD userId,const char *lpBuffer,int bufferSize, userFloodInfo *uFL, floodDefInfo *fDI)
{
	if(lpBuffer[0] == '$') return true;

	char nick[40];
	memset(nick, 0, 40);
	std::string buffer = lpBuffer;

	if(HexHub::Users::NickFromId(userId, nick))
	{
		if(dl->Find(nick))
		{
			std::string::size_type st;
			int off = 0;
			int i = 0;

			for (i=0; buffer[i] != 0; i++) {
				if (buffer[i] == '>') {
					off = i;
					break;
				}
			}

			if(buffer[off+2] == '!') return true;

			st = buffer.find("revolution", off);
			if(st != std::string::npos)
				buffer.replace(st, 10, "revalution");
			st = buffer.find("Lord_Zero", off);
			if(st != std::string::npos)
				buffer.replace(st, 9, "Lor_Zero");
			st = buffer.find("function", off);
			if(st != std::string::npos)
				buffer.replace(st, 8, "funktion");
			st = buffer.find("come on", off);
			if(st != std::string::npos)
				buffer.replace(st, 7, "come one");
			st = buffer.find("now on", off);
			if(st != std::string::npos)
				buffer.replace(st, 6, "now one");
			st = buffer.find("notice", off);
			if(st != std::string::npos)
				buffer.replace(st, 6, "notis");
			st = buffer.find("school", off);
			if(st != std::string::npos)
				buffer.replace(st, 6, "skool");
			st = buffer.find("photo", off);
			if(st != std::string::npos)
				buffer.replace(st, 5, "poto");
			st = buffer.find("since", off);
			if(st != std::string::npos)
				buffer.replace(st, 5, "seens");
			st = buffer.find(" are ", off);
			if(st != std::string::npos)
				buffer.replace(st, 5, " ar ");
			st = buffer.find("your", off);
			if(st != std::string::npos)
				buffer.replace(st, 4, "you");
			st = buffer.find("are ", off);
			if(st != std::string::npos)
				buffer.replace(st, 4, "ar ");
			st = buffer.find("boy", off);
			if(st != std::string::npos)
				buffer.replace(st, 3, "poy");
			st = buffer.find("ode", off);
			if(st != std::string::npos)
				buffer.replace(st, 3, "oed");
			st = buffer.find("oo", off);
			if(st != std::string::npos)
				buffer.replace(st, 2, "oe");
			st = buffer.find("ea", off);
			if(st != std::string::npos)
				buffer.replace(st, 2, "ee");

			HexHub::Data::SendToAll(buffer.c_str(), buffer.length());

			return false;
		}
		return true;
	}
	return true;
}